Ubuntu

erlang should not depend on wxwidgets2.8

Reported by Rick Spencer on 2009-09-28
64
This bug affects 12 people
Affects Status Importance Assigned to Milestone
erlang (Ubuntu)
High
Martin Pitt
Karmic
High
Martin Pitt

Bug Description

Binary package hint: erlang

currently, erlang has a build-dependency on wxwidgets2.8. it should definately not b-d on wxwidgets.

ProblemType: Bug
Architecture: i386
Date: Mon Sep 28 13:06:15 2009
DistroRelease: Ubuntu 9.10
Package: erlang (not installed)
ProcEnviron:
 PATH=(custom, user)
 LANG=en_US.UTF-8
 SHELL=/bin/bash
ProcVersionSignature: Ubuntu 2.6.31-11.36-generic
SourcePackage: erlang
Uname: Linux 2.6.31-11-generic i686

Related branches

Changed in erlang (Ubuntu):
importance: Undecided → High
assignee: nobody → Ken VanDine (ken-vandine)
milestone: none → ubuntu-9.10
LaMont Jones (lamont) on 2009-10-08
tags: added: karmic-autotest
Martin Pitt (pitti) wrote :

RC, since this also causes archive inconsistency (see http://people.canonical.com/~ubuntu-archive/component-mismatches.txt)

Changed in erlang (Ubuntu Karmic):
status: New → Triaged
Changed in erlang (Ubuntu Karmic):
assignee: Ken VanDine (ken-vandine) → Martin Pitt (pitti)
Martin Pitt (pitti) on 2009-10-16
Changed in erlang (Ubuntu Karmic):
status: Triaged → In Progress
Martin Pitt (pitti) wrote :

So if we remove support for wxwindows, this would mean to:

 - drop the erlang-wx binary package (universe)
 - Drop the immediate reverse dependencies, which are all built by the erlang source: erlang-reltool erlang-megaco erlang-debugger erlang-common-test

None of these packages have reverse dependencies.

Martin Pitt (pitti) wrote :

I don't think that -megaco, -common-test, and -reltool actually use wx, so I'll just drop the dependency. But I'll double-check.

Martin Pitt (pitti) wrote :

Uploaded, sitting in unapproved now.

Changed in erlang (Ubuntu Karmic):
status: In Progress → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package erlang - 1:13.b.1-dfsg-2ubuntu1

---------------
erlang (1:13.b.1-dfsg-2ubuntu1) karmic; urgency=low

  * debian/control:
    - Drop libwxgtk2.8-dev build dependency. Wx isn't in main, and not
      supposed to. (LP: #438365)
    - Drop erlang-wx binary.
    - Drop erlang-wx dependency from -megaco, -common-test, and -reltool, they
      do not really need wx. Also drop it from -debugger; the GUI needs wx,
      but it apparently has CLI bits as well, and is also needed by -megaco,
      so let's keep the package for now.

 -- Martin Pitt <email address hidden> Fri, 16 Oct 2009 09:40:16 +0200

Changed in erlang (Ubuntu Karmic):
status: Fix Committed → Fix Released
Johan Kiviniemi (ion) wrote :

Darn. It would be nice if erlang-wx were still available from Universe. I’d have used it in a program.

Hi Martin,

You wrote "it should definately not b-d on wxwidgets".
Could you please explain why do you think so?

wxWidgets binding (wxErlang) is the one of the main features in Erlang/OTP R13 release, and AFAIK many of the standard OTP applications (like debugger, etop, pman, et cetera) which use GUI are being migrated (or already were) to wxErlang from Erlang-GS.

Thus, I see no contras against inclusion erlang-wx to the Lucid at least.
If you know any, please state it here.

It's an Open Source, and I think one person should not make such important decisions.

Thank you in advance for an answer!

Regards,
Andrey.

Steve Langasek (vorlon) wrote :

Because wxwidgets is a toolkit with a massive code footprint that we cannot and should not support in the main archive, which means that so long as erlang is needed by other packages in Ubuntu main, it will not build-depend on wxwidgets.

Thank you very much for this explanation!
So, it's easier to download wxwidgets & erlang in source and build it. No problem ;)
One more question to you all.
Could you please point me somewhere where I can find out which packages in main depend on erlang?
I suppose that's couchdb, but may be some other also?
Is there a chance that these dependencies will be broken ever?
I mean, couchdb etc. will be removed from main?
Sorry for so much questions, I am really interested in it ;)

On Thu, Jan 14, 2010 at 10:50:19PM -0000, Andrey Pampukha wrote:
> Could you please point me somewhere where I can find out which packages
> in main depend on erlang?
> I suppose that's couchdb, but may be some other also?

$ grep-dctrl -FDepends erlang-base -a --not -FSource erlang -sPackage /var/lib/apt/lists/archive.ubuntu.com_ubuntu_dists_lucid_main_binary-amd64_Packages
Package: couchdb-bin
Package: rabbitmq-server
$

> Is there a chance that these dependencies will be broken ever?
> I mean, couchdb etc. will be removed from main?

On the desktop side, it would in fact be quite helpful if we had a couchdb
implementation that did not depend on erlang, because the erlang runtime
makes up a noticeable fraction of our CD size and is only used by one
component. But couchdb is not a trivial component to replace.

--
Steve Langasek Give me a lever long enough and a Free OS
Debian Developer to set it on, and I can move the world.
Ubuntu Developer http://www.debian.org/
<email address hidden> <email address hidden>

Thank you very much, Steve! As CouchDB is by definition "a free and open source document-oriented database written in the Erlang programming language", it will be really difficult to find a non erlang-dependent implementation :-).

Tim Farnum (simplismic) wrote :

It's a little disappointing that the Ubuntu distribution of erlang-OTP does not include a functional wx library, since that is now a standard part of the OTP definition. Why have erlang if you're not going to have the real thing?

Adam Lindberg (eproxus) wrote :

Have you actually used these packages? Reltool obviously needs the wx library since it is a graphical tool developed with the new library. See this bug: https://bugs.launchpad.net/ubuntu/+source/erlang/+bug/555700

Alessandro Sivieri (scattino) wrote :

Wouldn't be possible to create a separate package for the wx module? I mean, a dependency not installed by default, but still installable?

Steve Langasek (vorlon) wrote :

On Wed, May 12, 2010 at 06:44:08PM -0000, Alessandro Sivieri wrote:
> Wouldn't be possible to create a separate package for the wx module? I
> mean, a dependency not installed by default, but still installable?

wx has to be available at package build time in order for erlang to build
against it. If erlang is in main, the only way to do this is for wx to be
in main, which it won't be.

--
Steve Langasek Give me a lever long enough and a Free OS
Debian Developer to set it on, and I can move the world.
Ubuntu Developer http://www.debian.org/
<email address hidden> <email address hidden>

aleperalta (peralta-alejandro) wrote :

I want to use erlang-wx, but I also need to install rabbitmq and couchdb, packages that depend in erlang. Is there way to tell ubuntu/apt that I've erlan so the that dependencies (erlang-base) are not installed when I install this packages? It would be really great.

Thanks.

Alejandro

aleperalta (peralta-alejandro) wrote :

Never mind my last comment, I manually compiled my version of the whole OTP, installed it in /opt/erlang with ./configure --prefix=/opt/erlang. Then added to my .bashrc the following export PATH=/opt/bin/erlang:$PATH. I put /opt/bin/erlang first so when I run "erl" it finds the executable in /opt/ and not the one in /usr/lib/erlang (which is the one that the package manager installs).

Darren LaChausse (dlachausse) wrote :

I agree with the other posters that this is an unfortunate situation. Is there any way to provide an alternative, non-crippled version of Erlang/OTP that includes the wx module. erlang-wx is required for some useful programs.

Would it be possible to package up another erlang in universe using the alternatives system? I notice that there is a version of erlang-base with HIPE enabled, could something similar be done with wx?

I would be willing to devote time to such a project and even maintain such a package if someone would be willing to mentor me. I know I could just create a PPA, but I think this would be useful to enough users that it should really be part of the Universe repos.

Darren LaChausse (dlachausse) wrote :

Please disregard my last comment. I found that there is an 'erlang-dev' PPA available which I intend to use. That should pretty much take care of my erlang development needs.

Thanks.

Rehan Khan (rasker) wrote :

This is kind of a nonsensical arbitrary decision. Moving forward Erlang's preference is to use wx for GUI frontends (in particular the debugging and monitoring tools included with the Distribution) eventually deprecating the old tk based tools. It seems odd that a core part of a language's distribution is being dropped to support one application.

If space on the CD is the issue then a more sensible decision would be to build an embedded Erlang just for CouchDB's use and allow Erlang to exist as most users would expect. Erlang has been known to compile down to as much as 4Mb for embedded apps.

Sucks a bit for maintenance though.

Tim Farnum (simplismic) wrote :

As a person who is using erlang with a wx interface (the easiest way to get a gui with erlang), and I think the decision to make it impossible to get the full OTP erlang from Ubuntu is a clearcut example of a foolish consistency.

ynsta (stanypub) wrote :

This removal is raise an issue with wings3d package that can't be installed anymore (ubuntu 12.10) :

The following packages have unmet dependencies:
 wings3d : Depends: erlang-wx (>= 1:15.b.1-dfsg) but it is not installable

Max Reyes (c1254474) wrote :

Has there been any progress on the wings3d bug? I still cannot install it. Building it also raises issues with esdl. This is a real shame that such a foolish decision has been made without any thought given to consequences. Shame on you, ubuntu devs!

Filiprino (filiprino) wrote :

I need wxWidgets for Erlang and I can't install them. This bug is causing a lot of trouble.
Just build all the OTP as it should be.

Sam Hodge (q-sam) wrote :

I cannot install wings3d because of this bug, can we get a resolution?

sam

Tim-farnum (tim-farnum) wrote :

My solution has been to install Erlang OTP from the repository at
erlangsolutions.com, which is a full OTP. I haven't figured out a way to
convince packages like wings3d that it satisfies the erlang dependency, but
I suspect it's possible. I mostly use erlang for programming, so I haven't
put in much work at getting wings3d to work.

On Mon, Apr 15, 2013 at 10:00 PM, Sam Hodge <email address hidden> wrote:

> I cannot install wings3d because of this bug, can we get a resolution?
>
> sam
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/438365
>
> Title:
> erlang should not depend on wxwidgets2.8
>
> Status in “erlang” package in Ubuntu:
> Fix Released
> Status in “erlang” source package in Karmic:
> Fix Released
>
> Bug description:
> Binary package hint: erlang
>
> currently, erlang has a build-dependency on wxwidgets2.8. it should
> definately not b-d on wxwidgets.
>
> ProblemType: Bug
> Architecture: i386
> Date: Mon Sep 28 13:06:15 2009
> DistroRelease: Ubuntu 9.10
> Package: erlang (not installed)
> ProcEnviron:
> PATH=(custom, user)
> LANG=en_US.UTF-8
> SHELL=/bin/bash
> ProcVersionSignature: Ubuntu 2.6.31-11.36-generic
> SourcePackage: erlang
> Uname: Linux 2.6.31-11-generic i686
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/ubuntu/+source/erlang/+bug/438365/+subscriptions
>

Larry Williams (ltwilliams58) wrote :

It's disappointing that such decisions, well-meaning as they are, wind up breaking other pcakges that, even still, are available in repos. Software Center doesn't properly inform the user what is broken when they try to install such a package, only that there is a problem they need to fix. And when trying to install multiple packages, Software Center doesn't advise the user which package failed, an unfortunate situation for the average user.

I hope the decision to remove this package is reconsidered, or at least completed so that Ubuntu isn't left in a broken state, however slight.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers